#####################################################################################
#
# Module: m25custompowers
# Author: m25 (idea from DrMike)
# 
# Description: do a bit of power swapping magic to get custom characters to use the m25ai
#
#
# Version 3.052
#
#####################################################################################

#print "Loading m25custompowers.py v.3.2.0 final; branch = m25 branch 1"

import js
import os
import types

import datfiles
import chardata

import m25getset
import m25aidata
import m25ai
import m25template
import m25report

import ffxcustom

import string

import ffx
from ffx import *

import m25event

import time


TEMP_POWER_MAX = 300

ai_custompowerslots = {}

m25report.Report_SetChannel('CUSTOMPOWERS',1)
m25report.Report_SetChannel('CARRIER', 1)

def InitCustomPowers():
	global ai_custompowerslots
	ai_custompowerslots = {}
	for i in range(1,TEMP_POWER_MAX):
		ai_custompowerslots['zzz%i'%(i)] = {'power': None, 'char' : None}
	m25getset.SetMissionVar('ai_custompowerslots',ai_custompowerslots)
		#m25getset.SetMissionVar('zzztemp_power' + `i`, None)
		#m25getset.SetMissionVar('zzztemp_power_char' + `i`, None)

def AddCustomPowers(char):
	#print 'in custom powers'
	if int(js.Object_GetAttr(char,'complex')) < 1000:
		#print 'complex too low'
		return  #not a .hero file
	changelist = []
	cdata = None
	try:
		#print m25template.GetComplexTemplate(char)+'.hero'
		cdata = datfiles.Campaign_ReadHeroFile(m25template.GetComplexTemplate(char)+'.hero')
		#print cdata
	except:
		#print 'not a hero file'
		return
	if cdata == {}:
		#print 'not a hero file'
		return
	#cdata = chardata.GetCharacterData(char)
	for powdata in cdata['powers'].keys():
		power = cdata['powers'][powdata]
		tempname = GetTempPowerName(char,power['PowerName'])
		if tempname == None:
			m25report.Report('ERROR','Unable to create custom powers for ' + char + '.  All slots full.')
			return
		AddTempPower(tempname, power)
		changelist.append(datfiles.Campaign_ReadPowers()[tempname])
		ModifyAIDefinition(char,power['PowerName'],tempname)
	if changelist != []:
		#print changelist
		datfiles.Campaign_RewritePowers(ChangePowers=changelist)
		#CustomPowers_SavePowerSlots()
	js.loadPowers()
	
def GetNextTempPowerName():
	temp_num = m25getset.GetMissionVar('temp_power_number',default=1,integer=1)
	m25getset.SetMissionVar('temp_power_number',temp_num+1)
	return 'zzz'+`temp_num`

def AddTempPower(name, pdata):
	FileName = datfiles.GetDatFile('powers.dat')
	temp = datfiles.Campaign_ReadPowers()  #force existence of power data
	datfiles._PowerData[FileName][name] = pdata.copy()
	datfiles._PowerData[FileName][name]['PowerName'] = name
	datfiles._PowerData[FileName][name]['notForCustom'] = 1
	#print datfiles._PowerData[FileName][name]

def ModifyAIDefinition(char, power, newname):
	#print power,newname
	if js.Object_Exists(char):
		template = []
		template = m25template.GetComplexTemplate(char)
		ai_num = 0
		
		ai = m25ai.FindM25AI(char)[0:]
		trigger_num = 1
		for m in ai[1:]:
			if m[0] == 'timer':
				power_num = 2
				for n in m[2:]:
					newstring = ReplacePower(n,power,newname)
					#newstring = string.replace(n,power,newname)
					#print newstring
					ai[trigger_num][power_num] = newstring
					power_num = power_num + 1
			trigger_num = trigger_num + 1
		m25ai.AIReaderSetAI(char, ai)
		
def ReplacePower(line, powername, replacement):
	#print line
	start = -1
	current = 0
	for i in line:
		#print line[current:current+len(powername)], powername
		if line[current:current+len(powername)] == powername:
			#print 'FOUND!!!'
			#print line[current-1]
			#print line[current+len(powername)]
			if (line[current-1] in ['"',"'"]) and (line[current+len(powername)] in ['"',"'",'\\']) and (not (line[current-2] in ['='])):
				#print 'PROPER MATCH'
				start = current
		current = current + 1
	if start >= 0:
		newline = line[0:start-1] + `replacement` + line[start+len(powername)+1:]
		#print newline
		return newline
	return line
				
def CustomPowers_SavePowerSlots():
	global ai_custompowerslots
	m25getset.SetMissionVar('ai_custompowerslots',ai_custompowerslots)
	
def CustomPowers_GetPowerSlots():
	global ai_custompowerslots
	if ai_custompowerslots == {}:
		ai_custompowerslots = m25getset.GetMissionVar('ai_custompowerslots',default={})
		if ai_custompowerslots == {}:
			InitCustomPowers()
	return ai_custompowerslots				
			
def GetTempPowerName(char, powername):
	global ai_custompowerslots
	name = GetPowerName(char, powername, default=None)
	if name != None:
		return name
	slot = FindOpenPowerSlot()
	if slot == None:
		#CustomPowerGarbageCollection()
		slot = FindOpenPowerSlot()
	if slot != None:
		m25report.Report('CUSTOMPOWERS', 'using power slot %i for %s : %s'%(slot, m25template.GetComplexTemplate(char),powername))
		#print 'using power slot ' + `slot` + ' for ' + m25template.GetComplexTemplate(char) + ':' + powername
		#CustomPowers_GetPowerSlots()
		ai_custompowerslots['zzz%i'%(slot)]['power'] = powername
		ai_custompowerslots['zzz%i'%(slot)]['char'] = m25template.GetComplexTemplate(char)
		#m25getset.SetMissionVar('ai_custompowerslots',custompowerslots)
		#m25getset.SetMissionVar('zzztemp_power_char' + `slot`, m25template.GetComplexTemplate(char))
		#m25getset.SetMissionVar('zzztemp_power' + `slot`, powername)
		return 'zzz' + `slot`
	else:
		return None
	
def RemoveTempPower(temp, original, template):
	m25getset.SetMissionVar('zzztemp_power_char' + `i`, None)
	m25getset.SetMissionVar('zzztemp_power' + `i`, None)
	for ai in m25aidata.AIExtensions:
		ai_num = 0
		if ai[0] == template:
			trig_num = 1
			for m in ai[1:]:
				if m[0] == 'timer':
					power_num = 2
					for n in m[2:]:
						newstring = string.replace(n, temp, original)
						m25aidata.AIExtensions[ai_num][trig_num][power_num] = newstring
						power_num = power_num + 1
				trig_num = trig_num + 1
		ai_num = ai_num + 1

def FindOpenPowerSlot():
	custompowerslots = CustomPowers_GetPowerSlots()
	#custompowerslots = m25getset.GetMissionVar('ai_custompowerslots',default={})
	for i in range(1,TEMP_POWER_MAX):
		#if m25getset.GetMissionVar('zzztemp_power' + `i`,default=None) == None:
		if custompowerslots['zzz%i'%(i)]['power'] == None:
			return i
	return None

# def CustomPowerGarbageCollection():
# 	allchars = js.Mission_GetDynamicObjects()
# 	alltemplates == []
# 	for a in allchars:
# 		alltemplates.append(m25template.GetComplexTemplate(a))
# 	for i in range(1, TEMP_POWER_MAX):
# 		template = m25getset.GetMissionVar('zzztemp_power_char' + `i`, default=None)
# 		if (template != None) and (template in alltemplates):
# 			original = m25getset.GetMissionVar('zzztemp_power' + `i`, default=None)
# 			if original != None:
# 				RemoveTempPower('zzz'+`i`, original, template)
				
				
def GetPowerName(char, powername, default=None):
	custompowerslots = CustomPowers_GetPowerSlots()
	#custompowerslots = m25getset.GetMissionVar('ai_custompowerslots',default={})
	for i in range(1, TEMP_POWER_MAX):
		if custompowerslots['zzz%i'%(i)]['power'] == powername:
			template = m25template.GetComplexTemplate(char)
			if custompowerslots['zzz%i'%(i)]['char'] == template:
				return 'zzz%i'%(i)
# 		
# 		
# 		temp_power = m25getset.GetMissionVar('zzztemp_power' + `i`, default=None)
# 		temp_char = m25getset.GetMissionVar('zzztemp_power_char' + `i`,default=None)
# 		if (temp_power == powername) and (temp_char == template):
# 			return 'zzz'+`i`
	return default

def GetTruePowerName(char, powername, default=None):
	if powername[:3]=='zzz':
		custompowerslots = CustomPowers_GetPowerSlots()
		#custompowerslots = m25getset.GetMissionVar('ai_custompowerslots',default={})
		if custompowerslots.has_key(powername):
			return custompowerslots[powername]['power']
# 		return default
# 		i = int(powername[3:])
# 		#print 'true power number ' + `i`
# 		return m25getset.GetMissionVar('zzztemp_power'+`i`, default=default)
	return default	
	
	
specialtypestring = {datfiles.PT_SPECIAL_AFTERBURNER : 'afterburner',
	datfiles.PT_SPECIAL_ALTERATION : 'alteration',
	datfiles.PT_SPECIAL_ALTER_GENETIC_STRUCTURE : '',
	datfiles.PT_SPECIAL_ANIMATE_DEAD : '',
	datfiles.PT_SPECIAL_ANIMATE_DEAD_MINIONS :'',
	datfiles.PT_SPECIAL_BEZERKER : '',
	datfiles.PT_SPECIAL_BUOYANCY : 'buoyancy',
	datfiles.PT_SPECIAL_BURROW : '',
	datfiles.PT_SPECIAL_CEREBRAL_NORMALISATION : '',
	datfiles.PT_SPECIAL_CLOAK : 'cloak',
	datfiles.PT_SPECIAL_CLONE_SELF : '',
	datfiles.PT_SPECIAL_CLONE_TARGET : '',
	datfiles.PT_SPECIAL_DEEP_SENSOR : '',
	datfiles.PT_SPECIAL_DENSITY_MAXIMIZE : 'density',
	datfiles.PT_SPECIAL_DIMENSION_SHIFT : 'exile',
	datfiles.PT_SPECIAL_DISPLACE_IMAGE : 'displace',
	datfiles.PT_SPECIAL_DISRUPT_OBJECT : '',
	datfiles.PT_SPECIAL_DOPPELGANGER : '',
	datfiles.PT_SPECIAL_ELECTRIFY_SELF : '',
	datfiles.PT_SPECIAL_EMPATHY : 'empathy',
	datfiles.PT_SPECIAL_ENERGIZE : 'energise',
	datfiles.PT_SPECIAL_ENERGIZE_AREA : 'energysurge',
	datfiles.PT_SPECIAL_EP_DRAW : '',
	datfiles.PT_SPECIAL_EP_TRANSFER : 'energysurge',
	datfiles.PT_SPECIAL_HP_BALANCE : '',
	datfiles.PT_SPECIAL_IGNITE : '',
	datfiles.PT_SPECIAL_IMAGE_PROJECTOR : 'limeylure',
	datfiles.PT_SPECIAL_LAWORDER : '',
	datfiles.PT_SPECIAL_LIFE_GIFT : '',
	datfiles.PT_SPECIAL_LIVING_FIRES : '',
	datfiles.PT_SPECIAL_MOLECULAR_EXCITE : '',
	datfiles.PT_SPECIAL_MORPH : '',
	datfiles.PT_SPECIAL_NONE : '',
	datfiles.PT_SPECIAL_NORMALISE : '',
	datfiles.PT_SPECIAL_PATRIOT_CHARGE : '',
	datfiles.PT_SPECIAL_POSSESSION : '',
	datfiles.PT_SPECIAL_POWER_NULLIFICATION : 'powernull',
	datfiles.PT_SPECIAL_RALLY : 'rally',
	datfiles.PT_SPECIAL_REMOVE_DEFENCE : '',
	datfiles.PT_SPECIAL_SACRIFICE : '',
	datfiles.PT_SPECIAL_SONIC_BOOM : '',
	datfiles.PT_SPECIAL_SPEEDING_BULLET : '',
	datfiles.PT_SPECIAL_SPRINT : '',
	datfiles.PT_SPECIAL_TELEPORT_SELF : '',
	datfiles.PT_SPECIAL_TELEPORT_SWAP : '',
	datfiles.PT_SPECIAL_TUMBLE : '',
	datfiles.PT_SPECIAL_TUNNEL : '',
	datfiles.PT_SPECIAL_UNCLOAK : ''}	
	
damagetypestring = {datfiles.PT_DAMAGE_ACID : '',
	datfiles.PT_DAMAGE_ACID_BURN : 'acidburn',
	datfiles.PT_DAMAGE_BLIND : 'blind',
	datfiles.PT_DAMAGE_COLD : '',
	datfiles.PT_DAMAGE_CRUSH : '',
	datfiles.PT_DAMAGE_ELECTRICAL : '',
	datfiles.PT_DAMAGE_ENERGY : '',
	datfiles.PT_DAMAGE_FIRE : '',
	datfiles.PT_DAMAGE_FREEZE : 'frozen',
	datfiles.PT_DAMAGE_HEX : 'hex',
	datfiles.PT_DAMAGE_HYPNOSIS : 'hypnosis',
	datfiles.PT_DAMAGE_IRRADIATE : 'irradiate',
	datfiles.PT_DAMAGE_MENTAL_BLANK : 'blank',
	datfiles.PT_DAMAGE_OBJECTIFY : '',
	datfiles.PT_DAMAGE_PANIC : 'panic',
	datfiles.PT_DAMAGE_PIERCE : '',
	datfiles.PT_DAMAGE_POLYMORPH : 'polymorph',
	datfiles.PT_DAMAGE_RADIATION : '',
	datfiles.PT_DAMAGE_RAGE : 'rage',
	datfiles.PT_DAMAGE_SPECIAL : '',
	datfiles.PT_DAMAGE_SPEED_DECREASE : 'speeddecrease',
	datfiles.PT_DAMAGE_SPEED_INCREASE : 'speedincrease',
	datfiles.PT_DAMAGE_STASIS : 'stasis',
	datfiles.PT_DAMAGE_TOADIFY : 'toadify',
	datfiles.PT_DAMAGE_WATER : '',
	datfiles.PT_DAMAGE_WEAKEN : 'weaken'}		

def GetCarrierIndex(char,powername):
	#start = time.clock()
	index = 0
	template = m25template.GetComplexTemplate(char)
	power = datfiles.Campaign_ReadPowers()[powername]
	truepowername = GetTruePowerName(char,powername,default=powername)
	if power.has_key('SpecialType'): specialtype = power['SpecialType']
	else:
		specialtype = datfiles.PT_SPECIAL_NONE
	if power.has_key('DamageType'): damagetype = power['DamageType']
	else: 
		damagetype = datfiles.PT_DAMAGE_WATER
	carrier_list = []
	for e in ffxcustom.FFX_CARRIERS:
		if e[0] == template:
			if e[3] == truepowername:
				#print e[1], e[2]
				carrier_list.append('%sto%s'%(e[1],e[2]))
				#return index
			else:
				if e[3] == 'all':
					#print specialtypestring[specialtype], damagetypestring[damagetype]
					if (e[1] in [specialtypestring[specialtype], damagetypestring[damagetype], 'stun']):
						#print e[1], e[2]
						carrier_list.append('%sto%s'%(e[1],e[2]))
						#return index
		index = index + 1
		save_list = m25getset.GetMissionVar('%s_ai_carriers'%(template), default=[])
		save_index = -1
		if carrier_list:
			num = 0
			for s in save_list:
				if s == carrier_list:
					save_index = num
				num = num + 1
			if save_index == -1: #not already in the characters list of state swaps
				save_list.append(carrier_list)
				m25getset.SetMissionVar('%s_ai_carriers'%(template), save_list)
				save_index = len(save_list)-1
	#print 'getcarrierindex: total %f'%(time.clock()-start)
	return save_index
	#return carrier_list
	#return -1
	
def IsCarrierInit(char, powername):
	return m25getset.GetMissionVar('carrier_'+char+'_'+powername,default=0)
	
def SetCarrierInit(char, powername):
	m25getset.SetMissionVar('carrier_'+char+'_' + powername, 1)

	
def SetupCustomCarrier(event):
	template = m25template.GetComplexTemplate(event.string)
	carrier_index = m25getset.GetMissionVar('%s_ai_carriers'%(template), default=[])
	try:	
		carriers = carrier_index[int(event.user)]
	except:
		m25report.Report('ERROR', 'state swaps for %s of type %s set up incorrectly'%(event.string, template))
		return
	m25report.Report('CARRIER', '%s attempting %s on %s'%(event.string, repr(carriers), event.object))
	for c in carriers:
		eval('ffx.%s(event)'%(c))
		m25event.SetTimer(0.5,c,event.object, event.string)

def CharIsHeroFile(char):
	template = m25template.GetComplexTemplate(char)
	return TemplateIsHeroFile(template)
	
def TemplateIsHeroFile(template):
	if type(template) != types.StringType: return 0
	filename = os.path.join(datfiles.GetHeroFilePath(),template+'.hero')
	if not os.path.isfile(filename):
		return 0
	return 1
	