#print "Loading m25freeroamdata.py v.3.2.0 final; branch = m25 branch 1"

import m25getset

def GetFreeRoamLevel():
	return m25getset.GetMissionVar('_freeroam_level',default=None)
	
def SetFreeRoamLevel(level):
	m25getset.SetMissionVar('_freeroam_level', level, campaign=1)

def GetFreeRoamExit():
	return m25getset.GetMissionVar('_freeroam_exit',default=None)

def SetFreeRoamExit(level):
	m25getset.SetMissionVar('_freeroam_exit', level, campaign=1)
	
def GetFreeRoamBaseEntry():
	return m25getset.GetMissionVar('_freeroam_base_entry', default=None)
	
def SetFreeRoamBaseEntry(level):
	m25getset.SetMissionVar('_freeroam_base_entry', level, campaign=1)
	
def GetFreeRoamRecruited():
	return m25getset.GetMissionVar('_freeroam_recruited', default=[])
	
def SetFreeRoamRecruited(recruits):
	m25getset.SetMissionVar('_freeroam_recruited', recruits, campaign=1)
	
def AddFreeRoamRecruited(recruits):
	already_recruited = GetFreeRoamRecruited()
	for r in recruits:
		if r not in already_recruited:
			already_recruited.append(r)
	SetFreeRoamRecruited(already_recruited)	
	
def GetFreeRoamAvailableHeroes():
	return m25getset.GetMissionVar('_freeroam_available_heroes', default=[])
	
def SetFreeRoamAvailableHeroes(heroes):
	m25getset.SetMissionVar('_freeroam_available_heroes', heroes, campaign=1)

def AddFreeRoamAvailableHeroes(recruits):
	already_available = GetFreeRoamAvailableHeroes()
	for r in recruits:
		if r not in already_available:
			already_available.append(r)
	SetFreeRoamAvailableHeroes(already_available)	
	
def GetFreeRoamPrestigeTotal():
	return m25getset.GetMissionVar('_freeroam_prestige_total', default=0)
	
def SetFreeRoamPrestigeTotal(value):
	m25getset.SetMissionVar('_freeroam_prestige_total', value, campaign=1)
	
def GetFreeRoamTimeOfDay():
	return m25getset.GetMissionVar('_freeroam_timeofday', default=0)
	
def SetFreeRoamTimeOfDay(value):
	m25getset.SetMissionVar('_freeroam_timeofday', value, campaign=1)
	
def GetFreeRoamPrestigeBonus():
	return m25getset.GetMissionVar('_freeroam_prestige_bonus', default=0)
	
def SetFreeRoamPrestigeBonus(value):
	m25getset.SetMissionVar('_freeroam_prestige_bonus', value, campaign=1)	
	
def GetFreeRoamXPBonus():
	return m25getset.GetMissionVar('_freeroam_xp_bonus', default=0)
	
def SetFreeRoamXPBonus(value):
	m25getset.SetMissionVar('_freeroam_xp_bonus', value, campaign=1)	

def GetFreeRoamTemplateMap():
	return m25getset.GetMissionVar('_freeroam_template_map', default={})
	
def SetFreeRoamTemplateMap(mapping):
	m25getset.SetMissionVar('_freeroam_template_map', mapping, campaign=1)
	
def GetFreeRoamTemplateSavedName(template):
	mapping = GetFreeRoamTemplateMap()
	for m in mapping.keys():
		if mapping[m] == template: return m
	return template

def GetFreeRoamExtraStories():
	return m25getset.GetMissionVar('_freeroam_extra_stories', default=[])
	
def AddFreeRoamExtraStory(storyname):
	storylist = GetFreeRoamExtraStories()
	if storyname not in storylist: storylist.append(storyname)
	SetFreeRoamExtraStories(storylist)	
	
def SetFreeRoamExtraStories(storylist):
	m25getset.SetMissionVar('_freeroam_extra_stories', storylist, campaign=1)
	
def GetFreeRoamExits():
	return m25getset.GetMissionVar('freeroam_exit_status', default={})	
	
def SetFreeRoamExits(allexits):
	m25getset.SetMissionVar('freeroam_exit_status', allexits, campaign=1)