#print "Loading m25startup.py v.3.2.0 final; branch = m25 branch 1"

import ff
from ff import *

import js
from js import *
import cshelper
from cshelper import *

import m25ai
from m25ai import *

import m25getset
import m25event
import m25report
import m25story
from m25story import * #this has to be here so that events work
import m25pstory
import m25objective

import m25freeroamally
import m25freeroamdata
import m25enc
from m25enc import *

import m25freeroam
from m25freeroam import * #this has to be here so that events work
import freeroam_bonus
import freeroam_exit
import freeroam_level
import m25freeroam_campaign

import datfiles

import ffx
from ffx import *  #this has to be here so that events work

import time

#set reporting to go to the log file
STARTUP_REPORT = 'FREEROAM INIT'
m25report.Report_SetChannel(STARTUP_REPORT, 1)

RPG_XP_PER_LEVEL=10
RPG_CP_PER_LEVEL=10
RPG_XP_PER_MISSION=0
RPG_XP_PER_TRAINING=0
	
js.Mission_SetAttr('gametype_isfreeroam',1)


def Startup_Precache(storyfile):
	m25report.Report(STARTUP_REPORT, 'parsing story %s'%storyfile)
	storyset = m25pstory.PStory_MakeStoryFromFile(storyfile)
	m25report.Report(STARTUP_REPORT, 'adding stories to the story dictionary')
	for s in storyset: m25story.Storyline_AddStory(s)
	m25pstory.Pstory_DoPrecache()
	m25report.Report(STARTUP_REPORT, 'creating encounter spawn markers')
	m25enc.EncCreateAllMarkers()
	m25report.Report(STARTUP_REPORT, 'precaching complete')
	
def Startup_ExtraStories():	
	storylist = m25freeroamdata.GetFreeRoamExtraStories()
	for s in storylist:
		m25report.Report(STARTUP_REPORT, 'parsing extra story %s'%s)
		storyset = m25pstory.PStory_MakeStoryFromFile(s)
		for t in storyset:
			m25story.Storyline_AddStory(t)
	
def Startup_CheckInit(builtins, startingprestige, startingmap, isbase=0):
#	js.Camera_ForceAutoFade(1)
	#m25getset.TurnOffSavedVariables()
	#store the start map so that it can be used by m25freeroam.py
	m25getset.SetMissionVar('freeroam_startingmap', startingmap)
	m25getset.SetMissionVar('freeroam_startingprestige', startingprestige)
	
	#make sure ffx doesn't remove tempform characters!
	#js.Mission_SetAttr('shapeReady',1)

	#is this a restore?
	if Startup_CheckRestore(): 
		m25report.Report(STARTUP_REPORT, 'in restore state.  Exiting init and letting the restore timer take over.')
		return
	#is this a new start?
	if Startup_CheckNewStart():
		m25report.Report(STARTUP_REPORT, 'new campaign.  Loading default data.')
		Startup_LoadDefaultData(builtins, startingprestige, startingmap)
	else:
		m25report.Report(STARTUP_REPORT, 'continuation.  Loading transfered data.')
		Startup_LoadTransferData()
	#is the data valid?
	if not Startup_ValidData(isbase):
		m25report.Report(STARTUP_REPORT, 'map data invalid. Restarting.')
		Startup_Restart()
		return
	#base?
	if Startup_IsBase():
		m25report.Report(STARTUP_REPORT, 'in base.  Loading base screen.')
		Startup_LoadBase()
	else:
		#default
		m25report.Report(STARTUP_REPORT, 'in mission.  Loading mission.')
		#insert a hook into the 'heroes dead' cutscene
		cshelper.heroes_dead_cs[2][0]="ff.heroesDead()"
		#start the story
		Startup_StartMission()
	Startup_SetInitialized()
	Startup_SetRestoreComplete()
	m25event.SetTimer(1, 'Startup_RestoreTimer')


def Startup_GetStoryFile():
	return ff.freeroam_storyfile	
	
def Startup_CheckNewStart():
	if len(Mission_GetSquadList())==0:
		return 1
	return 0
	
def Startup_LoadDefaultData(builtins, startingprestige, startingmap):
	cshelper.setMission(1)
	#ffx.Mission_SetVar('start_exitpoint',freeroam_exit.exitPoint)
	#ffx.Mission_SetVar('start_prestigeBonus',freeroam_bonus.prestigeBonus)
	#ffx.Mission_SetVar('start_xpBonus',freeroam_bonus.xpBonus)
	#ffx.Mission_SetVar('start_herostates',freeroam_bonus.heroStates)
	#ffx.Mission_SetVar('start_encounters',freeroam_bonus.encounters)
	#ffx.Mission_SetVar('start_shots',freeroam_bonus.shots)
	js.Mission_SetAttr('prestigeBonus',0)
	js.Mission_SetAttr('xpBonus',0)
	js.Mission_SetAttr('timeofday',0)
	Startup_SetRequiredMap(startingmap)
	m25freeroamdata.SetFreeRoamLevel(startingmap)
	m25freeroamdata.SetFreeRoamExit(startingmap)
	#m25freeroamdata.SetFreeRoamBaseEntry(None)
	for hero in builtins:
		js.Campaign_AddHero(hero)
	#js.Campaign_AddHero('green_genie')
	#js.Campaign_AddHero('tombstone')
	js.Campaign_AddPrestige(startingprestige)
	for var in m25freeroam.FreeRoam_GetCampVariables():
		try: 
			exec('freeroam_campdata.%s=0'%(var))
			js.Mission_SetAttr(var,0)
		except: pass
# 	for v in m25freeroam_campaign.campWeapons:
# 		try: 
# 			exec('freeroam_campdata.%s_add=0'%(var))
# 			js.Mission_SetAttr(var+'_add',0)
# 		except: pass
	
		
def Startup_LoadTransferData():
	#insert a hook into the 'heroes dead' cutscene
	cshelper.heroes_dead_cs[2][0]="ff.heroesDead()"
	#js.Campaign_Recruit_Require(js.Mission_GetSquadList()[0])
	cshelper.setMission(1)
	required_level = freeroam_level.currentLevel
	Startup_SetRequiredMap(required_level)
	m25freeroam.FreeRoam_LoadCampaignData()
	js.Mission_SetAttr('prestigeBonus',freeroam_bonus.prestigeBonus)
	js.Mission_SetAttr('xpBonus',freeroam_bonus.xpBonus)
	#freeroam.FreeRoam_InitMission()
	#read in campaign dictionary
	m25getset.ReadVarDictionary()
	m25objective.Objective_RestoreObjectives()
	Startup_ExtraStories()
	

		
#check to see if the map loaded is the one set in the saved game.	
def Startup_ValidData(isbase=0):
	#if called from base.py and this is not a designated base map,
	# then the user has hit the 'back' button at the base selection screen
	#Swap the nextlevel and exitpoints, save and restart.
	if isbase and not (js.Marker_Exists('base_map')):
		m25report.Report(STARTUP_REPORT, 'user hit back button - reloading the correct base map.')
		Startup_SetRequiredMap(m25freeroamdata.GetFreeRoamExit())
		return 0
	required_level = Startup_GetRequiredMap()
	if required_level == '':
		m25report.Report(STARTUP_REPORT, 'required level is not set. This could result in an error.')
		required_level = m25freeroamdata.GetFreeRoamLevel() or freeroam_level.currentLevel
		Startup_SetRequiredMap(required_level)
	#find out what map is actually loaded
	if js.Marker_Exists('mapname_%s'%(required_level)):
		m25report.Report(STARTUP_REPORT, 'required map %s found.'%(required_level))
		return 1
	else:
		m25report.Report(STARTUP_REPORT, 'required map %s NOT found.'%(required_level))
		return 0
	
	
def Startup_SetRequiredMap(value):
	m25getset.SetMissionVar('_startup_requiredmap',value)
		
def Startup_GetRequiredMap():
	return m25getset.GetMissionVar('_startup_requiredmap',default='')

	
def Startup_Restart():
	#required_level = Startup_GetRequiredMap()
	required_level = m25freeroamdata.GetFreeRoamLevel() 
	m25freeroam.FreeRoam_NextLevel(required_level)
	
		
def Startup_IsBase():
	if Marker_Exists('base_map'):
		return 1
	return 0

def Startup_LoadBase():
	#recruit heroes here to make it stick!
	Startup_RecruitHeroes()
	m25freeroam.FreeRoam_InitBase()
	#js.Camera_LookAtMarker('camera')
	cshelper.look('camera',-210,180)
	#bring in stored allies
	m25enc.Enc_LoadEncounters()
	m25freeroamally.LoadFreeroamAllies('hero_1')
	#set the map that we entered the base from, but only if it isn't the current map
	#if m25freeroamdata.GetFreeRoamExit() != Startup_GetRequiredMap():
	#	m25freeroamdata.SetFreeRoamBaseEntry(m25freeroamdata.GetFreeRoamExit())
	#extra heroes the player brought in stay in the base!
	m25freeroamally.FreeroamAlly_ClearFreeroamHeroes()
	js.UI_Base_Enable(1)
	js.UI_Enable(0)
	cshelper.look('camera',-210,180)
	
def Startup_RecruitHeroes():
	for recruit in m25freeroamdata.GetFreeRoamRecruited():
		if not js.Campaign_IsRecruited(recruit): js.Campaign_Recruit(recruit)
	for available in m25freeroamdata.GetFreeRoamAvailableHeroes():
		js.Campaign_AddHero(available)
	#for set in m25freeroam_campaign.campHeroes:
	#	if Mission_GetAttr(set[0]) and js.Campaign_IsRecruited(set[0])==0:
	#		js.Campaign_Recruit(set[0])	

def Startup_StartMission():
	#start FFX at this point
	ffx.FFX_InitMission()
	#give the hero a special index so freeroam picks up the hero ok
	
	ffx.FFX_ObjectSetAttr('hero_1','originalIndex',69)
	m25freeroam.FreeRoam_InitMission()
	
	#bring in stored allies
	m25enc.Enc_LoadEncounters()
	m25freeroamally.LoadFreeroamAllies('hero_1')
	
	m25freeroamdata.SetFreeRoamLevel(freeroam_level.currentLevel)
	
	#I've added a generic story setup function here to make it work with EZ script
	#storyfile, mapname = Startup_GetStoryFile(), freeroam_level.currentLevel

	#run the story
	#startdo = time.clock()
	m25story.DoStoryline()
	#now = time.clock()
	#print "make: %f \t add: %f \t do:%f"%(startadd-startmake,startdo-startadd,now-startdo)
	#print 'MiniMod_InitFreeRoam complete.'
		
	
def Startup_SetInitialized():
	m25getset.SetMissionVar('_startup_initialized', 1)
	
def Startup_GetInitialized():
	return m25getset.GetMissionVar('_startup_initialized', default=0, number=1)
	
def Startup_CheckRestore():
	if not Startup_GetRestoreComplete():
		if Startup_GetInitialized():
			return 1
	return 0
	
def Startup_SetRestoreComplete():
	m25getset.SetMissionVar('_startup_restore_done',1,nosave=1)		
	
def Startup_GetRestoreComplete():
	return m25getset.GetMissionVar('_startup_restore_done', default=0, nosave=1)	
	
def Startup_RestoreTimer(event):
	m25event.SetTimer(1, 'Startup_RestoreTimer')
	if Startup_CheckRestore():
		m25report.Report(STARTUP_REPORT, 'restore found.')
		datfiles.Mission_ReadStartingMarkers(ForceRead=1)
		if Startup_ValidData():
			m25report.Report(STARTUP_REPORT, 'map data valid.')
			Startup_SetRestoreComplete()
			Startup_RestoreData()
			#if we are in a base - rerun the base setup
			if Startup_IsBase(): 
				m25report.Report(STARTUP_REPORT, 'restoring base.')
				Startup_LoadBase()
		else:
			m25report.Report(STARTUP_REPORT, 'restored map data invalid. Restarting.')
			Startup_Restart()

			
#this may better belong in freeroam or even ffx, but it is here pending reorganization
def Startup_RestoreData():
	#reset the weaponmaster data
	#m25freeroam.FreeRoam_SetupWeaponData()
	#reinitialise buoyancy
	for hero in cshelper.getAllHeroes():
		if js.Object_GetSecondaryStates(hero)& js.SCSTATE_BUOYANT:
			#this will kick in again for FFX fliers shortly...
			js.Object_SetSecondaryState(hero,js.SCSTATE_BUOYANT,0,js.REMOVE_STATE)
	#insert a hook into the 'heroes dead' cutscene
	cshelper.heroes_dead_cs[2][0]="ff.heroesDead()"
	#reload stories?
	storyfile = Startup_GetStoryFile()
	storyset = m25pstory.PStory_MakeStoryFromFile(storyfile)
	for s in storyset: m25story.Storyline_AddStory(s)
	Startup_ExtraStories()
	#save the data in case the player decides to do a restart
	m25freeroam.FreeRoam_WriteCampaignData()
	

			

def Startup_OnBriefing():
	#weapons turned off for now
	#m25freeroam.FreeRoam_ExitBase()
	m25freeroam.FreeRoam_OnExitBase()
	#print 'back at startup_onbriefing'
	#if js.Mission_GetAttr('briefing')!=0:
	#	exec( "play(briefing%d_cs)"%(js.Mission_GetAttr('briefing')) )
	#else:
	js.UI_Briefing_Done()
	#print 'ui_briefing_done'